%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%% src file for task 2 - genetic algorithems.
%%
%% $Author: tobibobi $ 
%% $Revision: 1.3 $
%%
%% $Log: opg2.tex,v $
%% Revision 1.3  2006-12-17 15:30:41  tobibobi
%% Inserted figures - expected ready
%%
%% Revision 1.2  2006/12/16 19:14:04  tobibobi
%% Completed both tasks
%%
%% Revision 1.1  2006/12/12 10:50:44  tobibobi
%% Created a skeleton tex file
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Genetic algorithms}
In this task, i will examine Genetic Algorithms and its abillity to
perform with different basic parameters. The program that i will use
for this task is the PGA program by Peter Ross

\subsection{Experiment 1}
In the first experiment i will first test what influence the
chromosome length has on the outcome. I start out with the default
length of 32 bits and the max-1 problem. The Max-1 will be used for
the rest of this experiment I have initially set the migration and the
mutation rate to 0.

The result as can be seen from one experimental run is as follows:

\begin{verbatim}
     Generation: 730      Evaluations so far: 3900
        Pop.......Average..........Best.(max = 32)
        0   =      32.0000000       32.0000000
        1   =      32.0000000       32.0000000
        2   =      30.0000000       30.0000000
        3   =      30.0000000       30.0000000
        4   =      30.0000000       30.0000000
\end{verbatim}

In this run, its only two of the five populations which reach a
complete result. The last tree is missing two bits each.

I repeat the task five times and gets simular results.

This is a risk when all the chromosomes from a single population has a
specific bit not set in either of the chromosomes. This will newer be
altered since the population is newer allowed to mutate - only
crossover. An crossover with an external population can aid in helping
this problem - but that is outside the scope of this experiemnt.

As i increase the chromosome length, the situation seems to worsen
even more as can be seen below with a length of 50 and 100:

\begin{verbatim}
            Generation: 780      Evaluations so far: 4150
        Pop.......Average..........Best.(max = 50)
        0   =      46.0000000       46.0000000
        1   =      49.0000000       49.0000000
        2   =      49.0000000       49.0000000
        3   =      46.0000000       46.0000000
        4   =      46.0000000       46.0000000

            Generation: 3540     Evaluations so far: 17950
        Pop.......Average..........Best.(max = 100)
        0   =      81.0000000       81.0000000
        1   =      82.0000000       82.0000000
        2   =      82.0000000       82.0000000
        3   =      85.0000000       85.0000000
        4   =      85.0000000       85.0000000
\end{verbatim}

By increasing the population size, the tendency can be lowered
somewhat as can bee seen by the below run - we show here with a
chromosome length of 100 and population size of 100 and 200.

\begin{verbatim}
            Generation: 2230     Evaluations so far: 11650
        Pop.......Average..........Best.(max = 100)
        0   =      91.0000000       91.0000000
        1   =      91.0000000       91.0000000
        2   =      92.0000000       92.0000000
        3   =      89.0000000       89.0000000
        4   =      90.0000000       90.0000000

            Generation: 4360     Evaluations so far: 22800
        Pop.......Average..........Best.(max = 100)
        0   =      99.0000000       99.0000000
        1   =     100.0000000      100.0000000
        2   =      97.0000000       97.0000000
        3   =      99.0000000       99.0000000
        4   =      98.0000000       98.0000000
\end{verbatim}

So this shows that the system can actually converge with a large
enough population. By having a larger population, the chance that all
bits set spread over a single population is bigger. 

Generally it is quite likely that all the different bits will be
represented in a smaller population, but since some of the chromosomes
sometimes is not selected for breeding, vital bits can also be lost in
this way.

The number of generations also increases since there is now wider
range of possible breed solutions available.

If i try to increase the population we can also raise the statistical
chance that an optimal solution will be found. It is therefore raised
to 400:
\begin{verbatim}
            Generation: 8430     Evaluations so far: 44150
        Pop.......Average..........Best.(max = 100)
        0   =     100.0000000      100.0000000
        1   =     100.0000000      100.0000000
        2   =     100.0000000      100.0000000
        3   =     100.0000000      100.0000000
        4   =     100.0000000      100.0000000
\end{verbatim}

Another possible choice could be to allow crossover to produce
twins. This reduces the chance for loss of bits and therefore could
convert faster.

The repetition of the above experiment produces the following result:
\begin{verbatim}
            Generation: 4370     Evaluations so far: 45700
        Pop.......Average..........Best.(max = 100)
        0   =     100.0000000      100.0000000
        1   =     100.0000000      100.0000000
        2   =     100.0000000      100.0000000
        3   =     100.0000000      100.0000000
        4   =     100.0000000      100.0000000
\end{verbatim}

This causes the number of generations to drop to nearly half, but
off course the number of evaluations happens at almost the same amount

\subsubsection{Conclusion}
The fact that a single population can tend to converge to a solution
in a fixed area can be a problem in a single population. This seems to
be possible to alter this by allowing crossover from other islands.
This is due to a single island becomming to simular, but compared with
another island it may be wery different and therefore it can produce a
rather fresh input to a population that is ``stuck!!''


\subsection{Experiment 2}
In this second experiment, i will examine whatever the rank selection
method or the fittest selection method proves the best result. First
to summarise, i will give a small description of the difference of the
two methods.

The fitness selection choose by examining the result of the evaluation
of the chromosome. If the chromosomes in question all performs almost
similar, they all get an similar chance to breed again on the other
hand the better an item does the bigger the amount of breeding's it can
produce - even to the point where its the only one breeding. This can
be perceived as a way of cake slicing where the better you do, the
greater slice you get.

When using rank selection, a forced choice is being made - even if the
chromosomes all performs almost similar, the best is always selected
even though it may only be slightly better than the rest. Since a
selection is enforced, this method is often considered more brutal
than the fitness function.

By looking at these initial two runs, its quickly visible that the
rank function reaches its goal as do fitness. But it also finds the
result faster.  So i will choose to use the number of iterations to
measure performance over a mean of five or more runs - which gives a
macroscopic view of the different runs.

\subsection{Experiment 3}
Now i will try to examine what kind of aid we get by crossover. The
opposite of crossover is only mutation. The first test i will try is
by the De Jong 3 (now DJ3) function. This will be tested by first having no crossover
and next normal two point crossover plus finally uniform crossover.
The final runs with DJ5 and modified binary 6 (now BF6), will be done only with no and
two-point crossover.

All runs are performed with initially following arguments:

\begin {verbatim} pga -P1 -p100 -srank \end{verbatim}

Then the result is presented in table

\begin{table}[ht!]
\centering
\begin{tabular}{lll}
Eval & crossover & mean iterations \\
\hline
DJ3 & none & 2000 - 3000\\
DJ3 & two & 1300 - 1500\\
DJ3 & uniform & 1200 - 1600 \\
\hline
DJ5 & none & 2600 - 7100 \\
DJ5 & two & 2500 - 4600 \\
\hline
BF6 & none & 2000 - 3000\\
BF6 & two & 2500 - 3500\\
BF6 & uniform & 4000 - 9000\\
\end{tabular}
\caption{Running with different types of crossover}
\label{tab:crossover}
\end{table}

It seems in table \vref{tab:crossover}, there are some differences in
the matter of the evaluation problem since it clear that the last BF6
evaluation function doesn't perform two well in the situation. I
suppose for this situation that the reason the crossover performs so
bad as it does in these scenarios is that the crossover is allowed to
switch in all positions.

\begin{table}[ht!]
\centering
\begin{tabular}{lll}
Eval & mutation & mean iterations \\
\hline
DJ3 & 0.03125 & 1300 - 1500 \\
DJ3 & 0.062 & 2800 - 3500 \\
DJ3 & 0.10 & 2800 - 3500 \\
\hline
DJ5 & 0.03125 & 2600 - 4000 \\ 
DJ5 & 0.062 & 3000 - 4000 \\
DJ5 & 0.1  & 3000 - 4000 \\
\hline
BF6  & 0.03125 & 3000 - 5000 \\ 
BF6  & 0.062 & 3000 - 5000 \\ 
BF6  & 0.10 & 2800 - 4000 \\ 
\end{tabular}
\caption{Running with different quantities of mutation (1,2,3 bits)}
\label{tab:mutation}
\end{table}

It again in table \vref{tab:mutation}, depends on the problem what
ever the results become. It seems for the DJ3 problem seems to suffer
when the mutation rate was changed from it orriginal 1 bit per
cromosome to a tree bit mutation. The BF6 problem tends to improwe
slightly when the amounts of bits changed per mutation increases.


\subsubsection{Conclusion}
In this final experiment i had a single idea that i considered
severel times, but could not see how i could get the PGA program to
perfrom: By having crossover in a direct binary form, its quite likely
that a single bit mutation can cause a huge difference. This is due to
dataseries may implementing as several longer than one bit
values. That means that a sudden crossover in the middle of such a
value, will have a huge a huge impact and therefore move it a far way
out of its current area. This can be avoided by using some level of
scheming to avoid violent crossovers - but i could not see how i could
get PGA to do such a task.

